{- This module was generated from data in the Kate syntax
   highlighting file sed.xml, version 1.0, by Bart Sas (bart.sas@gmail.com) -}

module Text.Highlighting.Kate.Syntax.Sed
          (highlight, parseExpression, syntaxName, syntaxExtensions)
where
import Text.Highlighting.Kate.Types
import Text.Highlighting.Kate.Common
import Text.ParserCombinators.Parsec hiding (State)
import Control.Monad.State
import Data.Char (isSpace)
import Data.Maybe (fromMaybe)

-- | Full name of language.
syntaxName :: String
syntaxName = "sed"

-- | Filename extensions for this language.
syntaxExtensions :: String
syntaxExtensions = "*.sed"

-- | Highlight source code using this syntax definition.
highlight :: String -> [SourceLine]
highlight input = evalState (mapM parseSourceLine $ lines input) startingState

parseSourceLine :: String -> State SyntaxState SourceLine
parseSourceLine = mkParseSourceLine parseExpression

-- | Parse an expression using appropriate local context.
parseExpression :: KateParser Token
parseExpression = do
  (lang,cont) <- currentContext
  result <- parseRules (lang,cont)
  optional $ do eof
                updateState $ \st -> st{ synStPrevChar = '\n' }
                pEndLine
  return result

startingState = SyntaxState {synStContexts = [("sed","BeginningOfLine")], synStLineNumber = 0, synStPrevChar = '\n', synStPrevNonspace = False, synStCaseSensitive = True, synStKeywordCaseSensitive = True, synStCaptures = []}

pEndLine = do
  updateState $ \st -> st{ synStPrevNonspace = False }
  context <- currentContext
  case context of
    ("sed","BeginningOfLine") -> return ()
    ("sed","FirstAddressRegex") -> pushContext ("sed","Error") >> return ()
    ("sed","AfterFirstAddress") -> pushContext ("sed","BeginningOfLine") >> return ()
    ("sed","AfterFirstAddress2") -> pushContext ("sed","BeginningOfLine") >> return ()
    ("sed","SecondAddress") -> pushContext ("sed","Error") >> return ()
    ("sed","SecondAddressRegex") -> pushContext ("sed","Error") >> return ()
    ("sed","AfterSecondAddress") -> pushContext ("sed","Error") >> return ()
    ("sed","Step") -> pushContext ("sed","Error") >> return ()
    ("sed","Command") -> pushContext ("sed","Error") >> return ()
    ("sed","SCommand") -> pushContext ("sed","Error") >> return ()
    ("sed","SRegex") -> pushContext ("sed","Error") >> return ()
    ("sed","SReplacement") -> pushContext ("sed","Error") >> return ()
    ("sed","SFlags") -> pushContext ("sed","BeginningOfLine") >> return ()
    ("sed","WFlag") -> pushContext ("sed","BeginningOfLine") >> return ()
    ("sed","YCommand") -> pushContext ("sed","Error") >> return ()
    ("sed","YSourceList") -> pushContext ("sed","Error") >> return ()
    ("sed","YDestList") -> pushContext ("sed","Error") >> return ()
    ("sed","AICCommand") -> pushContext ("sed","Error") >> return ()
    ("sed","LiteralText") -> pushContext ("sed","BeginningOfLine") >> return ()
    ("sed","BTCommand") -> pushContext ("sed","BeginningOfLine") >> return ()
    ("sed","WRCommand") -> pushContext ("sed","Error") >> return ()
    ("sed","LCommand") -> pushContext ("sed","BeginningOfLine") >> return ()
    ("sed","QCommand") -> pushContext ("sed","BeginningOfLine") >> return ()
    ("sed","Label") -> pushContext ("sed","Error") >> return ()
    ("sed","AfterCommand") -> pushContext ("sed","BeginningOfLine") >> return ()
    ("sed","Regex") -> pushContext ("sed","Error") >> return ()
    ("sed","Comment") -> pushContext ("sed","BeginningOfLine") >> return ()
    ("sed","Error") -> pushContext ("sed","BeginningOfLine") >> return ()
    _ -> return ()

withAttribute attr txt = do
  when (null txt) $ fail "Parser matched no text"
  updateState $ \st -> st { synStPrevChar = last txt
                          , synStPrevNonspace = synStPrevNonspace st || not (all isSpace txt) }
  return (attr, txt)


regex_'28'2f'29 = compileRegex "(/)"
regex_'5c'5c'28'5cS'29 = compileRegex "\\\\(\\S)"
regex_'5cS = compileRegex "\\S"
regex_'28'5cS'29 = compileRegex "(\\S)"
regex_'5c'5c'5b0'2d9LlUuE'5c'5c'26'5d = compileRegex "\\\\[0-9LlUuE\\\\&]"
regex_'5cS'2b = compileRegex "\\S+"
regex_'5cw'2b = compileRegex "\\w+"

defaultAttributes = [(("sed","BeginningOfLine"),NormalTok),(("sed","FirstAddressRegex"),StringTok),(("sed","AfterFirstAddress"),NormalTok),(("sed","AfterFirstAddress2"),NormalTok),(("sed","SecondAddress"),NormalTok),(("sed","SecondAddressRegex"),StringTok),(("sed","AfterSecondAddress"),NormalTok),(("sed","Step"),NormalTok),(("sed","Command"),NormalTok),(("sed","SCommand"),NormalTok),(("sed","SRegex"),StringTok),(("sed","SReplacement"),StringTok),(("sed","SFlags"),NormalTok),(("sed","WFlag"),NormalTok),(("sed","YCommand"),NormalTok),(("sed","YSourceList"),StringTok),(("sed","YDestList"),StringTok),(("sed","AICCommand"),NormalTok),(("sed","LiteralText"),OtherTok),(("sed","BTCommand"),NormalTok),(("sed","WRCommand"),NormalTok),(("sed","LCommand"),NormalTok),(("sed","QCommand"),NormalTok),(("sed","Label"),NormalTok),(("sed","AfterCommand"),NormalTok),(("sed","Regex"),StringTok),(("sed","Comment"),CommentTok),(("sed","Error"),ErrorTok)]

parseRules ("sed","BeginningOfLine") =
  (((pDetectSpaces >>= withAttribute NormalTok))
   <|>
   ((pDetectChar False '#' >>= withAttribute CommentTok) >>~ pushContext ("sed","Comment"))
   <|>
   ((pRegExpr regex_'28'2f'29 >>= withAttribute StringTok) >>~ pushContext ("sed","FirstAddressRegex"))
   <|>
   ((pRegExpr regex_'5c'5c'28'5cS'29 >>= withAttribute StringTok) >>~ pushContext ("sed","FirstAddressRegex"))
   <|>
   ((pInt >>= withAttribute DecValTok) >>~ pushContext ("sed","AfterFirstAddress"))
   <|>
   ((pDetectChar False '$' >>= withAttribute OtherTok) >>~ pushContext ("sed","AfterFirstAddress"))
   <|>
   ((pDetectChar False '}' >>= withAttribute NormalTok) >>~ pushContext ("sed","AfterCommand"))
   <|>
   ((pDetectChar False ':' >>= withAttribute FunctionTok) >>~ pushContext ("sed","Label"))
   <|>
   ((pDetectChar False '!' >>= withAttribute OtherTok) >>~ pushContext ("sed","Command"))
   <|>
   ((parseRules ("sed","Command")))
   <|>
   ((pRegExpr regex_'5cS >>= withAttribute ErrorTok) >>~ pushContext ("sed","Error"))
   <|>
   (currentContext >>= \x -> guard (x == ("sed","BeginningOfLine")) >> pDefault >>= withAttribute (fromMaybe NormalTok $ lookup ("sed","BeginningOfLine") defaultAttributes)))

parseRules ("sed","FirstAddressRegex") =
  (((pDetectSpaces >>= withAttribute StringTok))
   <|>
   ((pRegExprDynamic "\\\\%1" >>= withAttribute CharTok))
   <|>
   ((pRegExprDynamic "%1" >>= withAttribute StringTok) >>~ pushContext ("sed","AfterFirstAddress"))
   <|>
   ((parseRules ("sed","Regex")))
   <|>
   (currentContext >>= \x -> guard (x == ("sed","FirstAddressRegex")) >> pDefault >>= withAttribute (fromMaybe NormalTok $ lookup ("sed","FirstAddressRegex") defaultAttributes)))

parseRules ("sed","AfterFirstAddress") =
  (((pDetectSpaces >>= withAttribute NormalTok))
   <|>
   ((pDetectChar False '!' >>= withAttribute OtherTok) >>~ pushContext ("sed","Command"))
   <|>
   ((parseRules ("sed","AfterFirstAddress2")))
   <|>
   ((pRegExpr regex_'5cS >>= withAttribute ErrorTok) >>~ pushContext ("sed","Error"))
   <|>
   (currentContext >>= \x -> guard (x == ("sed","AfterFirstAddress")) >> pDefault >>= withAttribute (fromMaybe NormalTok $ lookup ("sed","AfterFirstAddress") defaultAttributes)))

parseRules ("sed","AfterFirstAddress2") =
  (((pDetectSpaces >>= withAttribute NormalTok))
   <|>
   ((pDetectChar False ',' >>= withAttribute NormalTok) >>~ pushContext ("sed","SecondAddress"))
   <|>
   ((pDetectChar False '~' >>= withAttribute NormalTok) >>~ pushContext ("sed","Step"))
   <|>
   ((parseRules ("sed","Command")))
   <|>
   ((pRegExpr regex_'5cS >>= withAttribute ErrorTok) >>~ pushContext ("sed","Error"))
   <|>
   (currentContext >>= \x -> guard (x == ("sed","AfterFirstAddress2")) >> pDefault >>= withAttribute (fromMaybe NormalTok $ lookup ("sed","AfterFirstAddress2") defaultAttributes)))

parseRules ("sed","SecondAddress") =
  (((pDetectSpaces >>= withAttribute NormalTok))
   <|>
   ((pRegExpr regex_'28'2f'29 >>= withAttribute StringTok) >>~ pushContext ("sed","SecondAddressRegex"))
   <|>
   ((pRegExpr regex_'5c'5c'28'5cS'29 >>= withAttribute StringTok) >>~ pushContext ("sed","SecondAddressRegex"))
   <|>
   ((pInt >>= withAttribute DecValTok) >>~ pushContext ("sed","AfterSecondAddress"))
   <|>
   ((pDetectChar False '$' >>= withAttribute OtherTok) >>~ pushContext ("sed","AfterSecondAddress"))
   <|>
   ((pRegExpr regex_'5cS >>= withAttribute ErrorTok) >>~ pushContext ("sed","Error"))
   <|>
   (currentContext >>= \x -> guard (x == ("sed","SecondAddress")) >> pDefault >>= withAttribute (fromMaybe NormalTok $ lookup ("sed","SecondAddress") defaultAttributes)))

parseRules ("sed","SecondAddressRegex") =
  (((pDetectSpaces >>= withAttribute StringTok))
   <|>
   ((pRegExprDynamic "\\\\%1" >>= withAttribute CharTok))
   <|>
   ((pRegExprDynamic "%1" >>= withAttribute StringTok) >>~ pushContext ("sed","AfterSecondAddress"))
   <|>
   ((parseRules ("sed","Regex")))
   <|>
   (currentContext >>= \x -> guard (x == ("sed","SecondAddressRegex")) >> pDefault >>= withAttribute (fromMaybe NormalTok $ lookup ("sed","SecondAddressRegex") defaultAttributes)))

parseRules ("sed","AfterSecondAddress") =
  (((pDetectSpaces >>= withAttribute NormalTok))
   <|>
   ((pDetectChar False '!' >>= withAttribute OtherTok) >>~ pushContext ("sed","Command"))
   <|>
   ((parseRules ("sed","Command")))
   <|>
   ((pRegExpr regex_'5cS >>= withAttribute ErrorTok) >>~ pushContext ("sed","Error"))
   <|>
   (currentContext >>= \x -> guard (x == ("sed","AfterSecondAddress")) >> pDefault >>= withAttribute (fromMaybe NormalTok $ lookup ("sed","AfterSecondAddress") defaultAttributes)))

parseRules ("sed","Step") =
  (((pDetectSpaces >>= withAttribute NormalTok))
   <|>
   ((pInt >>= withAttribute DecValTok) >>~ pushContext ("sed","Command"))
   <|>
   ((pRegExpr regex_'5cS >>= withAttribute ErrorTok) >>~ pushContext ("sed","Error"))
   <|>
   (currentContext >>= \x -> guard (x == ("sed","Step")) >> pDefault >>= withAttribute (fromMaybe NormalTok $ lookup ("sed","Step") defaultAttributes)))

parseRules ("sed","Command") =
  (((pDetectSpaces >>= withAttribute NormalTok))
   <|>
   ((pDetectChar False 's' >>= withAttribute KeywordTok) >>~ pushContext ("sed","SCommand"))
   <|>
   ((pDetectChar False 'y' >>= withAttribute KeywordTok) >>~ pushContext ("sed","YCommand"))
   <|>
   ((pAnyChar "dpnDNPhHgGxFvz=" >>= withAttribute KeywordTok) >>~ pushContext ("sed","AfterCommand"))
   <|>
   ((pAnyChar "aic" >>= withAttribute KeywordTok) >>~ pushContext ("sed","AICCommand"))
   <|>
   ((pAnyChar "bTt" >>= withAttribute KeywordTok) >>~ pushContext ("sed","BTCommand"))
   <|>
   ((pAnyChar "WwrR" >>= withAttribute KeywordTok) >>~ pushContext ("sed","WRCommand"))
   <|>
   ((pAnyChar "lL" >>= withAttribute KeywordTok) >>~ pushContext ("sed","LCommand"))
   <|>
   ((pAnyChar "qQ" >>= withAttribute KeywordTok) >>~ pushContext ("sed","QCommand"))
   <|>
   ((pDetectChar False '{' >>= withAttribute NormalTok) >>~ pushContext ("sed","BeginningOfLine"))
   <|>
   ((pRegExpr regex_'5cS >>= withAttribute ErrorTok) >>~ pushContext ("sed","Error"))
   <|>
   (currentContext >>= \x -> guard (x == ("sed","Command")) >> pDefault >>= withAttribute (fromMaybe NormalTok $ lookup ("sed","Command") defaultAttributes)))

parseRules ("sed","SCommand") =
  (((pDetectSpaces >>= withAttribute NormalTok))
   <|>
   ((pRegExpr regex_'28'5cS'29 >>= withAttribute StringTok) >>~ pushContext ("sed","SRegex"))
   <|>
   (currentContext >>= \x -> guard (x == ("sed","SCommand")) >> pDefault >>= withAttribute (fromMaybe NormalTok $ lookup ("sed","SCommand") defaultAttributes)))

parseRules ("sed","SRegex") =
  (((pDetectSpaces >>= withAttribute StringTok))
   <|>
   ((pRegExprDynamic "\\\\%1" >>= withAttribute CharTok))
   <|>
   ((pRegExprDynamic "(%1)" >>= withAttribute StringTok) >>~ pushContext ("sed","SReplacement"))
   <|>
   ((parseRules ("sed","Regex")))
   <|>
   (currentContext >>= \x -> guard (x == ("sed","SRegex")) >> pDefault >>= withAttribute (fromMaybe NormalTok $ lookup ("sed","SRegex") defaultAttributes)))

parseRules ("sed","SReplacement") =
  (((pDetectSpaces >>= withAttribute StringTok))
   <|>
   ((pRegExprDynamic "\\\\%1" >>= withAttribute CharTok))
   <|>
   ((pRegExprDynamic "%1" >>= withAttribute StringTok) >>~ pushContext ("sed","SFlags"))
   <|>
   ((pRegExpr regex_'5c'5c'5b0'2d9LlUuE'5c'5c'26'5d >>= withAttribute CharTok))
   <|>
   ((pDetectChar False '&' >>= withAttribute CharTok))
   <|>
   (currentContext >>= \x -> guard (x == ("sed","SReplacement")) >> pDefault >>= withAttribute (fromMaybe NormalTok $ lookup ("sed","SReplacement") defaultAttributes)))

parseRules ("sed","SFlags") =
  (((pDetectSpaces >>= withAttribute NormalTok))
   <|>
   ((pAnyChar "gpeIiMm" >>= withAttribute DataTypeTok))
   <|>
   ((pDetectChar False 'w' >>= withAttribute DataTypeTok) >>~ pushContext ("sed","WFlag"))
   <|>
   ((pInt >>= withAttribute DecValTok))
   <|>
   ((parseRules ("sed","AfterCommand")))
   <|>
   (currentContext >>= \x -> guard (x == ("sed","SFlags")) >> pDefault >>= withAttribute (fromMaybe NormalTok $ lookup ("sed","SFlags") defaultAttributes)))

parseRules ("sed","WFlag") =
  (((pDetectSpaces >>= withAttribute NormalTok))
   <|>
   ((pRegExpr regex_'5cS'2b >>= withAttribute BaseNTok) >>~ pushContext ("sed","SFlags"))
   <|>
   (currentContext >>= \x -> guard (x == ("sed","WFlag")) >> pDefault >>= withAttribute (fromMaybe NormalTok $ lookup ("sed","WFlag") defaultAttributes)))

parseRules ("sed","YCommand") =
  (((pDetectSpaces >>= withAttribute NormalTok))
   <|>
   ((pRegExpr regex_'28'5cS'29 >>= withAttribute StringTok) >>~ pushContext ("sed","YSourceList"))
   <|>
   (currentContext >>= \x -> guard (x == ("sed","YCommand")) >> pDefault >>= withAttribute (fromMaybe NormalTok $ lookup ("sed","YCommand") defaultAttributes)))

parseRules ("sed","YSourceList") =
  (((pDetectSpaces >>= withAttribute StringTok))
   <|>
   ((pRegExprDynamic "\\\\%1" >>= withAttribute CharTok))
   <|>
   ((pRegExprDynamic "(%1)" >>= withAttribute StringTok) >>~ pushContext ("sed","YDestList"))
   <|>
   ((pDetect2Chars False '\\' 'n' >>= withAttribute CharTok))
   <|>
   ((pDetect2Chars False '\\' '\\' >>= withAttribute CharTok))
   <|>
   (currentContext >>= \x -> guard (x == ("sed","YSourceList")) >> pDefault >>= withAttribute (fromMaybe NormalTok $ lookup ("sed","YSourceList") defaultAttributes)))

parseRules ("sed","YDestList") =
  (((pDetectSpaces >>= withAttribute StringTok))
   <|>
   ((pRegExprDynamic "\\\\%1" >>= withAttribute CharTok))
   <|>
   ((pRegExprDynamic "%1" >>= withAttribute StringTok) >>~ pushContext ("sed","AfterCommand"))
   <|>
   ((pDetect2Chars False '\\' 'n' >>= withAttribute CharTok))
   <|>
   ((pDetect2Chars False '\\' '\\' >>= withAttribute CharTok))
   <|>
   (currentContext >>= \x -> guard (x == ("sed","YDestList")) >> pDefault >>= withAttribute (fromMaybe NormalTok $ lookup ("sed","YDestList") defaultAttributes)))

parseRules ("sed","AICCommand") =
  (((pDetectSpaces >>= withAttribute NormalTok))
   <|>
   ((pLineContinue >>= withAttribute OtherTok) >>~ pushContext ("sed","LiteralText"))
   <|>
   ((pRegExpr regex_'5cS >>= withAttribute ErrorTok) >>~ pushContext ("sed","Error"))
   <|>
   (currentContext >>= \x -> guard (x == ("sed","AICCommand")) >> pDefault >>= withAttribute (fromMaybe NormalTok $ lookup ("sed","AICCommand") defaultAttributes)))

parseRules ("sed","LiteralText") =
  (((pDetect2Chars False '\\' '\\' >>= withAttribute OtherTok) >>~ pushContext ("sed","LiteralText"))
   <|>
   ((pLineContinue >>= withAttribute OtherTok) >>~ pushContext ("sed","LiteralText"))
   <|>
   ((pDetectChar False '\\' >>= withAttribute ErrorTok) >>~ pushContext ("sed","Error"))
   <|>
   (currentContext >>= \x -> guard (x == ("sed","LiteralText")) >> pDefault >>= withAttribute (fromMaybe NormalTok $ lookup ("sed","LiteralText") defaultAttributes)))

parseRules ("sed","BTCommand") =
  (((pDetectSpaces >>= withAttribute NormalTok))
   <|>
   ((pRegExpr regex_'5cw'2b >>= withAttribute FunctionTok) >>~ pushContext ("sed","AfterCommand"))
   <|>
   ((parseRules ("sed","AfterCommand")))
   <|>
   (currentContext >>= \x -> guard (x == ("sed","BTCommand")) >> pDefault >>= withAttribute (fromMaybe NormalTok $ lookup ("sed","BTCommand") defaultAttributes)))

parseRules ("sed","WRCommand") =
  (((pDetectSpaces >>= withAttribute NormalTok))
   <|>
   ((pRegExpr regex_'5cS'2b >>= withAttribute BaseNTok) >>~ pushContext ("sed","AfterCommand"))
   <|>
   (currentContext >>= \x -> guard (x == ("sed","WRCommand")) >> pDefault >>= withAttribute (fromMaybe NormalTok $ lookup ("sed","WRCommand") defaultAttributes)))

parseRules ("sed","LCommand") =
  (((pDetectSpaces >>= withAttribute NormalTok))
   <|>
   ((pInt >>= withAttribute DecValTok) >>~ pushContext ("sed","AfterCommand"))
   <|>
   ((parseRules ("sed","AfterCommand")))
   <|>
   (currentContext >>= \x -> guard (x == ("sed","LCommand")) >> pDefault >>= withAttribute (fromMaybe NormalTok $ lookup ("sed","LCommand") defaultAttributes)))

parseRules ("sed","QCommand") =
  (((pDetectSpaces >>= withAttribute NormalTok))
   <|>
   ((pInt >>= withAttribute DecValTok) >>~ pushContext ("sed","AfterCommand"))
   <|>
   ((parseRules ("sed","AfterCommand")))
   <|>
   (currentContext >>= \x -> guard (x == ("sed","QCommand")) >> pDefault >>= withAttribute (fromMaybe NormalTok $ lookup ("sed","QCommand") defaultAttributes)))

parseRules ("sed","Label") =
  (((pDetectSpaces >>= withAttribute NormalTok))
   <|>
   ((pRegExpr regex_'5cw'2b >>= withAttribute FunctionTok) >>~ pushContext ("sed","AfterCommand"))
   <|>
   ((pRegExpr regex_'5cS >>= withAttribute ErrorTok) >>~ pushContext ("sed","Error"))
   <|>
   (currentContext >>= \x -> guard (x == ("sed","Label")) >> pDefault >>= withAttribute (fromMaybe NormalTok $ lookup ("sed","Label") defaultAttributes)))

parseRules ("sed","AfterCommand") =
  (((pDetectSpaces >>= withAttribute NormalTok))
   <|>
   ((pDetectChar False ';' >>= withAttribute NormalTok) >>~ pushContext ("sed","BeginningOfLine"))
   <|>
   ((pDetectChar False '}' >>= withAttribute NormalTok) >>~ pushContext ("sed","AfterCommand"))
   <|>
   ((pDetectChar False '#' >>= withAttribute CommentTok) >>~ pushContext ("sed","Comment"))
   <|>
   ((pRegExpr regex_'5cS >>= withAttribute ErrorTok) >>~ pushContext ("sed","Error"))
   <|>
   (currentContext >>= \x -> guard (x == ("sed","AfterCommand")) >> pDefault >>= withAttribute (fromMaybe NormalTok $ lookup ("sed","AfterCommand") defaultAttributes)))

parseRules ("sed","Regex") =
  (((pDetect2Chars False '\\' '(' >>= withAttribute CharTok))
   <|>
   ((pDetect2Chars False '\\' ')' >>= withAttribute CharTok))
   <|>
   ((pDetect2Chars False '\\' '+' >>= withAttribute CharTok))
   <|>
   ((pDetect2Chars False '\\' '?' >>= withAttribute CharTok))
   <|>
   ((pDetect2Chars False '\\' '|' >>= withAttribute CharTok))
   <|>
   ((pDetect2Chars False '\\' '{' >>= withAttribute CharTok))
   <|>
   ((pDetect2Chars False '\\' '}' >>= withAttribute CharTok))
   <|>
   ((pDetect2Chars False '\\' '[' >>= withAttribute CharTok))
   <|>
   ((pDetect2Chars False '\\' ']' >>= withAttribute CharTok))
   <|>
   ((pDetect2Chars False '\\' '.' >>= withAttribute CharTok))
   <|>
   ((pDetect2Chars False '\\' '*' >>= withAttribute CharTok))
   <|>
   ((pDetect2Chars False '\\' '\\' >>= withAttribute CharTok))
   <|>
   ((pDetect2Chars False '\\' '^' >>= withAttribute CharTok))
   <|>
   ((pDetect2Chars False '\\' '$' >>= withAttribute CharTok))
   <|>
   ((pDetect2Chars False '\\' 'n' >>= withAttribute CharTok))
   <|>
   ((pDetect2Chars False '\\' 't' >>= withAttribute CharTok))
   <|>
   ((pDetect2Chars False '\\' '0' >>= withAttribute CharTok))
   <|>
   ((pDetect2Chars False '\\' '1' >>= withAttribute CharTok))
   <|>
   ((pDetect2Chars False '\\' '2' >>= withAttribute CharTok))
   <|>
   ((pDetect2Chars False '\\' '3' >>= withAttribute CharTok))
   <|>
   ((pDetect2Chars False '\\' '4' >>= withAttribute CharTok))
   <|>
   ((pDetect2Chars False '\\' '5' >>= withAttribute CharTok))
   <|>
   ((pDetect2Chars False '\\' '6' >>= withAttribute CharTok))
   <|>
   ((pDetect2Chars False '\\' '7' >>= withAttribute CharTok))
   <|>
   ((pDetect2Chars False '\\' '8' >>= withAttribute CharTok))
   <|>
   ((pDetect2Chars False '\\' '9' >>= withAttribute CharTok))
   <|>
   ((pDetectChar False '*' >>= withAttribute CharTok))
   <|>
   ((pDetectChar False '.' >>= withAttribute CharTok))
   <|>
   ((pDetectChar False '^' >>= withAttribute CharTok))
   <|>
   ((pDetectChar False '$' >>= withAttribute CharTok))
   <|>
   ((pDetectChar False '[' >>= withAttribute CharTok))
   <|>
   ((pDetectChar False ']' >>= withAttribute CharTok))
   <|>
   (currentContext >>= \x -> guard (x == ("sed","Regex")) >> pDefault >>= withAttribute (fromMaybe NormalTok $ lookup ("sed","Regex") defaultAttributes)))

parseRules ("sed","Comment") =
  (currentContext >>= \x -> guard (x == ("sed","Comment")) >> pDefault >>= withAttribute (fromMaybe NormalTok $ lookup ("sed","Comment") defaultAttributes))

parseRules ("sed","Error") =
  (currentContext >>= \x -> guard (x == ("sed","Error")) >> pDefault >>= withAttribute (fromMaybe NormalTok $ lookup ("sed","Error") defaultAttributes))


parseRules x = parseRules ("sed","BeginningOfLine") <|> fail ("Unknown context" ++ show x)
